Index: uspace/lib/c/generic/adt/hash_set.c
===================================================================
--- uspace/lib/c/generic/adt/hash_set.c	(revision c8c43caeaf653de4af38ee1f5fbcddf8d9850cdd)
+++ uspace/lib/c/generic/adt/hash_set.c	(revision c8c43caeaf653de4af38ee1f5fbcddf8d9850cdd)
@@ -0,0 +1,382 @@
+/*
+ * Copyright (c) 2008 Jakub Jermar
+ * Copyright (c) 2011 Radim Vansa
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libc
+ * @{
+ */
+/** @file
+ */
+
+#include <adt/hash_set.h>
+#include <adt/list.h>
+#include <unistd.h>
+#include <malloc.h>
+#include <assert.h>
+#include <str.h>
+
+/** Create chained hash set
+ *
+ * @param     h         Hash set structure to be initialized.
+ * @param[in] hash      Hash function
+ * @param[in] equals    Equals function
+ * @param[in] init_size Initial hash set size
+ *
+ * @return True on success
+ *
+ */
+int hash_set_init(hash_set_t *h, hash_set_hash hash, hash_set_equals equals,
+    size_t init_size)
+{
+	assert(h);
+	assert(hash);
+	assert(equals);
+	
+	if (init_size < HASH_SET_MIN_SIZE)
+		init_size = HASH_SET_MIN_SIZE;
+	
+	h->table = malloc(init_size * sizeof(link_t));
+	if (!h->table)
+		return false;
+	
+	for (size_t i = 0; i < init_size; i++)
+		list_initialize(&h->table[i]);
+	
+	h->size = init_size;
+	h->count = 0;
+	h->hash = hash;
+	h->equals = equals;
+	
+	return true;
+}
+
+/** Destroy a hash table instance.
+ *
+ * @param h Hash table to be destroyed.
+ *
+ */
+void hash_set_destroy(hash_set_t *h)
+{
+	assert(h);
+	free(h->table);
+}
+
+/** Rehash the internal table to new table
+ *
+ * @param h         Original hash set
+ * @param new_table Memory for the new table
+ * @param new_size  Size of the new table
+ */
+static void hash_set_rehash(hash_set_t *h, list_t *new_table,
+    size_t new_size)
+{
+	assert(new_size >= HASH_SET_MIN_SIZE);
+	
+	for (size_t bucket = 0; bucket < new_size; bucket++)
+		list_initialize(&new_table[bucket]);
+	
+	for (size_t bucket = 0; bucket < h->size; bucket++) {
+		link_t *cur;
+		link_t *next;
+		
+		for (cur = h->table[bucket].head.next;
+		    cur != &h->table[bucket].head;
+		    cur = next) {
+			next = cur->next;
+			list_append(cur, &new_table[h->hash(cur) % new_size]);
+		}
+	}
+	
+	list_t *old_table = h->table;
+	h->table = new_table;
+	free(old_table);
+	h->size = new_size;
+}
+
+/** Insert item into the set.
+ *
+ * If the set already contains equivalent object,
+ * the function fails.
+ *
+ * @param h    Hash table.
+ * @param key  Array of all keys necessary to compute hash index.
+ * @param item Item to be inserted into the hash table.
+ *
+ * @return True if the object was inserted
+ * @return Ffalse if the set already contained equivalent object.
+ *
+ */
+int hash_set_insert(hash_set_t *h, link_t *item)
+{
+	assert(item);
+	assert(h);
+	assert(h->hash);
+	assert(h->equals);
+	
+	unsigned long hash = h->hash(item);
+	unsigned long chain = hash % h->size;
+	
+	list_foreach(h->table[chain], cur) {
+		if (h->equals(cur, item))
+			return false;
+	}
+	
+	if (h->count + 1 > h->size) {
+		size_t new_size = h->size * 2;
+		list_t *temp = malloc(new_size * sizeof(list_t));
+		if (temp != NULL)
+			hash_set_rehash(h, temp, new_size);
+		
+		/*
+		 * If the allocation fails, just use the same
+		 * old table and try to rehash next time.
+		 */
+		chain = hash % h->size;
+	}
+	
+	h->count++;
+	list_append(item, &h->table[chain]);
+	
+	return true;
+}
+
+/** Search the hash set for a matching object and return it
+ *
+ * @param h    Hash set
+ * @param item The item that should equal to the matched object
+ *
+ * @return Matching item on success, NULL if there is no such item.
+ *
+ */
+link_t *hash_set_find(hash_set_t *h, const link_t *item)
+{
+	assert(h);
+	assert(h->hash);
+	assert(h->equals);
+	
+	unsigned long chain = h->hash(item) % h->size;
+	
+	list_foreach(h->table[chain], cur) {
+		if (h->equals(cur, item))
+			return cur;
+	}
+	
+	return NULL;
+}
+
+/** Remove first matching object from the hash set and return it
+ *
+ * @param h    Hash set.
+ * @param item The item that should be equal to the matched object
+ *
+ * @return The removed item or NULL if this is not found.
+ *
+ */
+link_t *hash_set_remove(hash_set_t *h, const link_t *item)
+{
+	assert(h);
+	assert(h->hash);
+	assert(h->equals);
+	
+	link_t *cur = hash_set_find(h, item);
+	if (cur) {
+		list_remove(cur);
+		
+		h->count--;
+		if (4 * h->count < h->size && h->size > HASH_SET_MIN_SIZE) {
+			size_t new_size = h->size / 2;
+			if (new_size < HASH_SET_MIN_SIZE)
+				/* possible e.g. if init_size == HASH_SET_MIN_SIZE + 1 */
+				new_size = HASH_SET_MIN_SIZE;
+			
+			list_t *temp = malloc(new_size * sizeof (list_t));
+			if (temp != NULL)
+				hash_set_rehash(h, temp, new_size);
+		}
+	}
+	
+	return cur;
+}
+
+/** Remove all elements for which the function returned non-zero
+ *
+ * The function can also destroy the element.
+ *
+ * @param h   Hash set.
+ * @param f   Function to be applied.
+ * @param arg Argument to be passed to the function.
+ *
+ */
+void hash_set_remove_selected(hash_set_t *h, int (*f)(link_t *, void *),
+    void *arg)
+{
+	assert(h);
+	assert(h->table);
+	
+	for (size_t bucket = 0; bucket < h->size; bucket++) {
+		link_t *prev = &h->table[bucket].head;
+		link_t *cur;
+		link_t *next;
+		
+		for (cur = h->table[bucket].head.next;
+		    cur != &h->table[bucket].head;
+		    cur = next) {
+			next = cur->next;
+			if (f(cur, arg)) {
+				prev->next = next;
+				next->prev = prev;
+				h->count--;
+			} else
+				prev = cur;
+		}
+	}
+	
+	if (4 * h->count < h->size && h->size > HASH_SET_MIN_SIZE) {
+		size_t new_size = h->size / 2;
+		if (new_size < HASH_SET_MIN_SIZE)
+			/* possible e.g. if init_size == HASH_SET_MIN_SIZE + 1 */
+			new_size = HASH_SET_MIN_SIZE;
+		
+		list_t *temp = malloc(new_size * sizeof (list_t));
+		if (temp != NULL)
+			hash_set_rehash(h, temp, new_size);
+	}
+}
+
+/** Apply function to all items in hash set
+ *
+ * @param h   Hash set.
+ * @param f   Function to be applied.
+ * @param arg Argument to be passed to the function.
+ *
+ */
+void hash_set_apply(hash_set_t *h, void (*f)(link_t *, void *), void *arg)
+{
+	assert(h);
+	assert(h->table);
+	
+	for (size_t bucket = 0; bucket < h->size; bucket++) {
+		link_t *cur;
+		link_t *next;
+		
+		for (cur = h->table[bucket].head.next;
+		    cur != &h->table[bucket].head;
+		    cur = next) {
+			
+			/*
+			 * The next pointer must be stored prior to the functor
+			 * call to allow using destructor as the functor (the
+			 * free function could overwrite the cur->next pointer).
+			 */
+			next = cur->next;
+			f(cur, arg);
+		}
+	}
+}
+
+/** Remove all elements from the set.
+ *
+ * The table is reallocated to the minimum size.
+ *
+ * @param h   Hash set
+ * @param f   Function (destructor?) applied to all element. Can be NULL.
+ * @param arg Argument to the destructor.
+ *
+ */
+void hash_set_clear(hash_set_t *h, void (*f)(link_t *, void *), void *arg)
+{
+	assert(h);
+	assert(h->table);
+	
+	for (size_t bucket = 0; bucket < h->size; bucket++) {
+		link_t *cur;
+		link_t *next;
+		
+		for (cur = h->table[bucket].head.next;
+		    cur != &h->table[bucket].head;
+		    cur = next) {
+			next = cur->next;
+			list_remove(cur);
+			if (f != NULL)
+				f(cur, arg);
+		}
+	}
+	
+	assert(h->size >= HASH_SET_MIN_SIZE);
+	list_t *new_table =
+	    realloc(h->table, HASH_SET_MIN_SIZE * sizeof(list_t));
+	
+	/* We are shrinking, therefore we shouldn't get NULL */
+	assert(new_table);
+	
+	if (h->table != new_table) {
+		/* Init the lists, pointers to itself are used in them */
+		for (size_t bucket = 0; bucket < HASH_SET_MIN_SIZE; ++bucket)
+			list_initialize(&new_table[bucket]);
+		
+		h->table = new_table;
+	}
+	
+	h->count = 0;
+	h->size = HASH_SET_MIN_SIZE;
+}
+
+/** Get hash set size
+ *
+ * @param hHash set
+ *
+ * @return Number of elements in the set.
+ *
+ */
+size_t hash_set_count(const hash_set_t *h)
+{
+	assert(h);
+	return h->count;
+}
+
+/** Check whether element is contained in the hash set
+ *
+ * @param h    Hash set
+ * @param item Item that should be equal to the matched object
+ *
+ * @return True if the hash set contains equal object
+ * @return False otherwise
+ *
+ */
+int hash_set_contains(const hash_set_t *h, const link_t *item)
+{
+	/*
+	 * The hash_set_find cannot accept constant hash set,
+	 * because we can modify the returned element. But in
+	 * this case we are using it safely.
+	 */
+	return hash_set_find((hash_set_t *) h, item) != NULL;
+}
+
+/** @}
+ */
Index: uspace/lib/c/generic/adt/hash_table.c
===================================================================
--- uspace/lib/c/generic/adt/hash_table.c	(revision a52de0ea49d86563c5209f5780a0c9d431c14235)
+++ uspace/lib/c/generic/adt/hash_table.c	(revision c8c43caeaf653de4af38ee1f5fbcddf8d9850cdd)
@@ -76,4 +76,24 @@
 	
 	return true;
+}
+
+/** Remove all elements from the hash table
+ *
+ * @param h Hash table to be cleared
+ */
+void hash_table_clear(hash_table_t *h)
+{
+	for (hash_count_t chain = 0; chain < h->entries; ++chain) {
+		link_t *cur;
+		link_t *next;
+		
+		for (cur = h->entry[chain].head.next;
+		    cur != &h->entry[chain].head;
+		    cur = next) {
+			next = cur->next;
+			list_remove(cur);
+			h->op->remove_callback(cur);
+		}
+	}
 }
 
@@ -190,5 +210,5 @@
 }
 
-/** Apply fucntion to all items in hash table.
+/** Apply function to all items in hash table.
  *
  * @param h   Hash table.
@@ -198,9 +218,17 @@
  */
 void hash_table_apply(hash_table_t *h, void (*f)(link_t *, void *), void *arg)
-{
-	hash_index_t bucket;
-	
-	for (bucket = 0; bucket < h->entries; bucket++) {
-		list_foreach(h->entry[bucket], cur) {
+{	
+	for (hash_index_t bucket = 0; bucket < h->entries; bucket++) {
+		link_t *cur;
+		link_t *next;
+
+		for (cur = h->entry[bucket].head.next; cur != &h->entry[bucket].head;
+		    cur = next) {
+			/*
+			 * The next pointer must be stored prior to the functor
+			 * call to allow using destructor as the functor (the
+			 * free function could overwrite the cur->next pointer).
+			 */
+			next = cur->next;
 			f(cur, arg);
 		}
Index: uspace/lib/c/generic/adt/list.c
===================================================================
--- uspace/lib/c/generic/adt/list.c	(revision a52de0ea49d86563c5209f5780a0c9d431c14235)
+++ uspace/lib/c/generic/adt/list.c	(revision c8c43caeaf653de4af38ee1f5fbcddf8d9850cdd)
@@ -33,5 +33,5 @@
 /**
  * @file
- * @brief	Functions completing doubly linked circular list implementaion.
+ * @brief	Functions completing doubly linked circular list implementation.
  *
  * This file contains some of the functions implementing doubly linked circular lists.
Index: uspace/lib/c/generic/async.c
===================================================================
--- uspace/lib/c/generic/async.c	(revision a52de0ea49d86563c5209f5780a0c9d431c14235)
+++ uspace/lib/c/generic/async.c	(revision c8c43caeaf653de4af38ee1f5fbcddf8d9850cdd)
@@ -1846,8 +1846,6 @@
 	
 	fibril_mutex_lock(&async_sess_mutex);
-	
+
 	int rc = async_hangup_internal(sess->phone);
-	if (rc == EOK)
-		free(sess);
 	
 	while (!list_empty(&sess->exch_list)) {
@@ -1861,4 +1859,6 @@
 		free(exch);
 	}
+
+	free(sess);
 	
 	fibril_mutex_unlock(&async_sess_mutex);
Index: uspace/lib/c/generic/ddi.c
===================================================================
--- uspace/lib/c/generic/ddi.c	(revision a52de0ea49d86563c5209f5780a0c9d431c14235)
+++ uspace/lib/c/generic/ddi.c	(revision c8c43caeaf653de4af38ee1f5fbcddf8d9850cdd)
@@ -53,22 +53,24 @@
 }
 
-/** Map piece of physical memory to task.
+/** Map a piece of physical memory to task.
  *
  * Caller of this function must have the CAP_MEM_MANAGER capability.
  *
- * @param pf		Physical address of the starting frame.
- * @param vp		Virtual address of the starting page.
- * @param pages		Number of pages to map.
- * @param flags		Flags for the new address space area.
+ * @param pf    Physical address of the starting frame.
+ * @param vp    Virtual address of the starting page.
+ * @param pages Number of pages to map.
+ * @param flags Flags for the new address space area.
  *
- * @return 		0 on success, EPERM if the caller lacks the
- *			CAP_MEM_MANAGER capability, ENOENT if there is no task
- *			with specified ID and ENOMEM if there was some problem
- *			in creating address space area.
+ * @return EOK on success
+ * @return EPERM if the caller lacks the CAP_MEM_MANAGER capability
+ * @return ENOENT if there is no task with specified ID
+ * @return ENOMEM if there was some problem in creating
+ *         the address space area.
+ *
  */
-int physmem_map(void *pf, void *vp, unsigned long pages, int flags)
+int physmem_map(void *pf, void *vp, size_t pages, unsigned int flags)
 {
-	return __SYSCALL4(SYS_PHYSMEM_MAP, (sysarg_t) pf, (sysarg_t) vp, pages,
-	    flags);
+	return __SYSCALL4(SYS_PHYSMEM_MAP, (sysarg_t) pf, (sysarg_t) vp,
+	    pages, flags);
 }
 
Index: uspace/lib/c/generic/device/hw_res_parsed.c
===================================================================
--- uspace/lib/c/generic/device/hw_res_parsed.c	(revision c8c43caeaf653de4af38ee1f5fbcddf8d9850cdd)
+++ uspace/lib/c/generic/device/hw_res_parsed.c	(revision c8c43caeaf653de4af38ee1f5fbcddf8d9850cdd)
@@ -0,0 +1,203 @@
+/*
+ * Copyright (c) 2011 Jiri Michalec
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libc
+ * @{
+ */
+/** @file
+ */
+
+#include <device/hw_res_parsed.h>
+#include <malloc.h>
+#include <assert.h>
+#include <errno.h>
+
+static void hw_res_parse_add_irq(hw_res_list_parsed_t *out, hw_resource_t *res,
+    int flags)
+{
+	assert(res && (res->type == INTERRUPT));
+	
+	int irq = res->res.interrupt.irq;
+	size_t count = out->irqs.count;
+	int keep_duplicit = flags & HW_RES_KEEP_DUPLICIT;
+	
+	if (!keep_duplicit) {
+		for (size_t i = 0; i < count; i++) {
+			if (out->irqs.irqs[i] == irq)
+				return;
+		}
+	}
+	
+	out->irqs.irqs[count] = irq;
+	out->irqs.count++;
+}
+
+static void hw_res_parse_add_io_range(hw_res_list_parsed_t *out,
+    hw_resource_t *res, int flags)
+{
+	assert(res && (res->type == IO_RANGE));
+	
+	uint64_t address = res->res.io_range.address;
+	endianness_t endianness = res->res.io_range.endianness;
+	size_t size = res->res.io_range.size;
+	
+	if ((size == 0) && (!(flags & HW_RES_KEEP_ZERO_AREA)))
+		return;
+	
+	int keep_duplicit = flags & HW_RES_KEEP_DUPLICIT;
+	size_t count = out->io_ranges.count;
+	
+	if (!keep_duplicit) {
+		for (size_t i = 0; i < count; i++) {
+			uint64_t s_address = out->io_ranges.ranges[i].address;
+			size_t s_size = out->io_ranges.ranges[i].size;
+			
+			if ((address == s_address) && (size == s_size))
+				return;
+		}
+	}
+	
+	out->io_ranges.ranges[count].address = address;
+	out->io_ranges.ranges[count].endianness = endianness;
+	out->io_ranges.ranges[count].size = size;
+	out->io_ranges.count++;
+}
+
+static void hw_res_parse_add_mem_range(hw_res_list_parsed_t *out,
+    hw_resource_t *res, int flags)
+{
+	assert(res && (res->type == MEM_RANGE));
+	
+	uint64_t address = res->res.mem_range.address;
+	endianness_t endianness = res->res.mem_range.endianness;
+	size_t size = res->res.mem_range.size;
+	
+	if ((size == 0) && (!(flags & HW_RES_KEEP_ZERO_AREA)))
+		return;
+	
+	int keep_duplicit = flags & HW_RES_KEEP_DUPLICIT;
+	size_t count = out->mem_ranges.count;
+	
+	if (!keep_duplicit) {
+		for (size_t i = 0; i < count; ++i) {
+			uint64_t s_address = out->mem_ranges.ranges[i].address;
+			size_t s_size = out->mem_ranges.ranges[i].size;
+			
+			if ((address == s_address) && (size == s_size))
+				return;
+		}
+	}
+	
+	out->mem_ranges.ranges[count].address = address;
+	out->mem_ranges.ranges[count].endianness = endianness;
+	out->mem_ranges.ranges[count].size = size;
+	out->mem_ranges.count++;
+}
+
+/** Parse list of hardware resources
+ *
+ * @param      hw_resources Original structure resource
+ * @param[out] out          Output parsed resources
+ * @param      flags        Flags of the parsing.
+ *                          HW_RES_KEEP_ZERO_AREA for keeping
+ *                          zero-size areas, HW_RES_KEEP_DUPLICITIES
+ *                          for keep duplicit areas
+ *
+ * @return EOK if succeed, error code otherwise.
+ *
+ */
+int hw_res_list_parse(hw_resource_list_t *hw_resources,
+    hw_res_list_parsed_t *out, int flags)
+{
+	if ((!hw_resources) || (!out))
+		return EINVAL;
+	
+	size_t res_count = hw_resources->count;
+	hw_res_list_parsed_clean(out);
+	
+	out->irqs.irqs = malloc(res_count * sizeof(int));
+	out->io_ranges.ranges = malloc(res_count * sizeof(io_range_t));
+	out->mem_ranges.ranges = malloc(res_count * sizeof(mem_range_t));
+	
+	for (size_t i = 0; i < res_count; ++i) {
+		hw_resource_t *resource = &(hw_resources->resources[i]);
+		
+		switch (resource->type) {
+		case INTERRUPT:
+			hw_res_parse_add_irq(out, resource, flags);
+			break;
+		case IO_RANGE:
+			hw_res_parse_add_io_range(out, resource, flags);
+			break;
+		case MEM_RANGE:
+			hw_res_parse_add_mem_range(out, resource, flags);
+			break;
+		default:
+			return EINVAL;
+		}
+	}
+	
+	return EOK;
+};
+
+/** Get hw_resources from the parent device.
+ *
+ * The output must be inited, will be cleared
+ *
+ * @see get_hw_resources
+ * @see hw_resources_parse
+ *
+ * @param sess                Session to the parent device
+ * @param hw_resources_parsed Output list
+ * @param flags               Parsing flags
+ *
+ * @return EOK if succeed, error code otherwise
+ *
+ */
+int hw_res_get_list_parsed(async_sess_t *sess,
+    hw_res_list_parsed_t *hw_res_parsed, int flags)
+{
+	if (!hw_res_parsed)
+		return EBADMEM;
+	
+	hw_resource_list_t hw_resources;
+	hw_res_list_parsed_clean(hw_res_parsed);
+	bzero(&hw_resources, sizeof(hw_resource_list_t));
+	
+	int rc = hw_res_get_resource_list(sess, &hw_resources);
+	if (rc != EOK)
+		return rc;
+	
+	rc = hw_res_list_parse(&hw_resources, hw_res_parsed, flags);
+	hw_res_clean_resource_list(&hw_resources);
+	
+	return rc;
+};
+
+/** @}
+ */
